gtksourceviewmm: Gsv::UndoManager Class Reference

gtksourceviewmm 3.18.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gsv::UndoManager Class Reference

Undo manager interface for View. More...

`#include <gtksourceviewmm/undomanager.h>`

Inheritance diagram for Gsv::UndoManager:
[legend]

## Public Member Functions
| UndoManager (UndoManager&& src) noexcept
UndoManager& | operator= (UndoManager&& src) noexcept
virtual | ~UndoManager () noexcept
GtkSourceUndoManager* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkSourceUndoManager* | gobj () const
| Provides access to the underlying C GObject. More...
bool | can_undo () const
| Get whether there are undo operations available. More...
bool | can_redo () const
| Get whether there are redo operations available. More...
void | undo ()
| Perform a single undo. More...
void | redo ()
| Perform a single redo. More...
void | begin_not_undoable_action ()
| Begin a not undoable action on the buffer. More...
void | end_not_undoable_action ()
| Ends a not undoable action on the buffer. More...
void | can_undo_changed ()
| Emits the 'can-undo-changed' signal. More...
void | can_redo_changed ()
| Emits the 'can-redo-changed' signal. More...
Glib::SignalProxy0< void > | signal_can_undo_changed ()
| Emitted when the ability to undo has changed. More...
Glib::SignalProxy0< void > | signal_can_redo_changed ()
| Emitted when the ability to redo has changed. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
virtual | ~Interface () noexcept
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable ()
| trackable (const trackable &src)
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| UndoManager ()
| You should derive from this class to use it. More...
virtual void | on_can_undo_changed ()
| This is a default handler for the signal signal_can_undo_changed(). More...
virtual void | on_can_redo_changed ()
| This is a default handler for the signal signal_can_redo_changed(). More...
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gsv::UndoManager > | wrap (GtkSourceUndoManager* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Undo manager interface for View.

The UndoManager interface can be implemented to provide custom undo management to a Buffer. Use Buffer::set_undo_manager() to install a custom undo manager for a particular source buffer.

Use UndoManager::can_undo_changed() and UndoManager::can_redo_changed() when respectively the undo state or redo state of the undo stack has changed.

Since gtksourceviewmm 2.10:

## Constructor & Destructor Documentation

Gsv::UndoManager::UndoManager | ( |  | ) |
| protected

You should derive from this class to use it.

Gsv::UndoManager::UndoManager | ( | UndoManager&& | src | ) |
| noexcept

virtual Gsv::UndoManager::~UndoManager | ( |  | ) |
| virtualnoexcept

## Member Function Documentation

static void Gsv::UndoManager::add_interface | ( | GType | gtype_implementer | ) |
| static

void Gsv::UndoManager::begin_not_undoable_action | ( |  | ) |

Begin a not undoable action on the buffer.

All changes between this call and the call to end_not_undoable_action() cannot be undone. This function should be re-entrant.

Since gtksourceviewmm 2.10:

bool Gsv::UndoManager::can_redo | ( |  | ) | const

Get whether there are redo operations available.

Returns
  `true` if there are redo operations available, `false` otherwise.

Since gtksourceviewmm 2.10:

void Gsv::UndoManager::can_redo_changed | ( |  | ) |

Emits the 'can-redo-changed' signal.

Since gtksourceviewmm 2.10:

bool Gsv::UndoManager::can_undo | ( |  | ) | const

Get whether there are undo operations available.

Returns
  `true` if there are undo operations available, `false` otherwise.

Since gtksourceviewmm 2.10:

void Gsv::UndoManager::can_undo_changed | ( |  | ) |

Emits the 'can-undo-changed' signal.

Since gtksourceviewmm 2.10:

void Gsv::UndoManager::end_not_undoable_action | ( |  | ) |

Ends a not undoable action on the buffer.

Since gtksourceviewmm 2.10:

static GType Gsv::UndoManager::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GtkSourceUndoManager* Gsv::UndoManager::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GtkSourceUndoManager* Gsv::UndoManager::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

virtual void Gsv::UndoManager::on_can_redo_changed | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_can_redo_changed().

virtual void Gsv::UndoManager::on_can_undo_changed | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_can_undo_changed().

UndoManager& Gsv::UndoManager::operator= | ( | UndoManager&& | src | ) |
| noexcept

void Gsv::UndoManager::redo | ( |  | ) |

Perform a single redo.

Calling this function when there are no redo operations available is an error. Use can_redo() to find out if there are redo operations available.

Since gtksourceviewmm 2.10:

Glib::SignalProxy0< void > Gsv::UndoManager::signal_can_redo_changed | ( |  | ) |

Emitted when the ability to redo has changed.

Slot Prototype:
  `void on_my_can_redo_changed()`

Glib::SignalProxy0< void > Gsv::UndoManager::signal_can_undo_changed | ( |  | ) |

Emitted when the ability to undo has changed.

Slot Prototype:
  `void on_my_can_undo_changed()`

void Gsv::UndoManager::undo | ( |  | ) |

Perform a single undo.

Calling this function when there are no undo operations available is an error. Use can_undo() to find out if there are undo operations available.

Since gtksourceviewmm 2.10:

## Friends And Related Function Documentation

Glib::RefPtr< Gsv::UndoManager > wrap | ( | GtkSourceUndoManager * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.